public class Kugel extends Koerper {

    private double radius;

    public Kugel(Punkt p, String farbe, double radius) {
        super(p,farbe);
	this.radius = radius;
    }

    public void skaliere(double alpha) {
        this.radius = this.radius * alpha;
    }

    public double berechneVolumen() {
        return 4.0 / 3.0 * Math.PI * Math.pow(radius,3);
    }

    public double berechneOberflaeche() {
        return 4 * Math.PI * this.radius * this.radius;
    }

    public boolean enthaeltPunkt(Punkt q) {
        Punkt  p = this.gibPunkt();
	double xdelta = p.gibX() - q.gibX();
	double ydelta = p.gibY() - q.gibY();
	double zdelta = p.gibZ() - q.gibZ();

	return xdelta*xdelta + ydelta*ydelta + zdelta*zdelta <= this.radius * this.radius;
    }

    public void drucke() {
       System.out.printf("Der Koerper ist eine Kugel mit einem Radius von %f.\n", this.radius);
       super.drucke();
    }
}
