public class Quader extends Koerper {

    private double breite;
    private double tiefe;
    private double hoehe;

    public Quader(Punkt p, String farbe, double breite, double tiefe, double hoehe) {
        super(p,farbe);
	this.breite = breite;
	this.tiefe = tiefe;
	this.hoehe = hoehe;
    }

    public void skaliere(double alpha) {
        this.breite = alpha * this.breite;    
        this.tiefe  = alpha * this.tiefe;    
        this.hoehe  = alpha * this.hoehe;    
    }

    public double berechneVolumen() {
        return this.breite * this.tiefe * this.hoehe;
    }

    public double berechneOberflaeche() {
        return 2 * (this.breite*this.tiefe + this.breite*this.hoehe + this.tiefe*this.hoehe);
    }

    public boolean enthaeltPunkt(Punkt q) {
        Punkt p = this.gibPunkt();
        
	return p.gibX() <= q.gibX() && p.gibX() + this.breite >= q.gibX() &&
	       p.gibY() <= q.gibY() && p.gibY() + this.tiefe >= q.gibY() &&
               p.gibZ() <= q.gibZ() && p.gibZ() + this.hoehe >= q.gibZ();
    }

    public void drucke() {
        System.out.printf(
	    "Der Koerper ist ein Quader mit einer Breite von %f, einer Tiefe von %f und einer Hoehe von %f\n",
	    this.breite, this.tiefe, this.hoehe);
        super.drucke();
    }
}
